import { __decorate, __param } from 'tslib';
import { Inject, PLATFORM_ID, ɵɵdefineInjectable, ɵɵinject, Injectable } from '@angular/core';
import { isPlatformServer } from '@angular/common';

var Angular2MaterializeV1Service_1;
let Angular2MaterializeV1Service = Angular2MaterializeV1Service_1 = class Angular2MaterializeV1Service {
    // tslint:disable-next-line:ban-types
    constructor(platformId) {
        this.platformId = platformId;
    }
    static carouselMouseOverTouchStart() {
        const instance = M.Carousel.getInstance(this);
        if (!instance) {
            return;
        }
        if (instance.autoScrollIntervalId) {
            window.clearInterval(instance.autoScrollIntervalId);
            instance.autoScrollIntervalId = undefined;
        }
    }
    static carouselMouseOutTouchEnd() {
        const instance = M.Carousel.getInstance(this);
        if (!instance) {
            return;
        }
        if (!instance.autoScrollIntervalId) {
            instance.autoScrollIntervalId = window.setInterval(() => {
                instance.next();
            }, instance.options.autoScroll);
        }
    }
    static getElements(elms) {
        if (elms.charAt(0) === '#') {
            elms = elms.replace('#', '');
            return document.getElementById(elms);
        }
        return document.querySelectorAll(elms);
    }
    static removeAutoScroll(instance) {
        if (instance.autoScrollIntervalId) {
            window.clearInterval(instance.autoScrollIntervalId);
            instance.autoScrollIntervalId = undefined;
        }
        instance.el.removeEventListener('mouseover', Angular2MaterializeV1Service_1.carouselMouseOverTouchStart);
        instance.el.removeEventListener('mouseleave', Angular2MaterializeV1Service_1.carouselMouseOutTouchEnd);
        instance.el.removeEventListener('touchstart', Angular2MaterializeV1Service_1.carouselMouseOverTouchStart);
        instance.el.removeEventListener('touchend', Angular2MaterializeV1Service_1.carouselMouseOutTouchEnd);
    }
    addAutoScroll(instance) {
        if (!instance.options.autoScroll) {
            return;
        }
        instance.autoScrollIntervalId = window.setInterval(() => {
            instance.next();
        }, instance.options.autoScroll);
        instance.el.addEventListener('mouseover', Angular2MaterializeV1Service_1.carouselMouseOverTouchStart, { passive: true });
        instance.el.addEventListener('mouseleave', Angular2MaterializeV1Service_1.carouselMouseOutTouchEnd, { passive: true });
        instance.el.addEventListener('touchstart', Angular2MaterializeV1Service_1.carouselMouseOverTouchStart, { passive: true });
        instance.el.addEventListener('touchend', Angular2MaterializeV1Service_1.carouselMouseOutTouchEnd, { passive: true });
    }
    autoInit() {
        if (isPlatformServer(this.platformId)) {
            return null;
        }
        return M.AutoInit();
    }
    destroyCarousel(instances) {
        if (isPlatformServer(this.platformId)) {
            return null;
        }
        if (Array.isArray(instances)) {
            for (const instance of instances) {
                Angular2MaterializeV1Service_1.removeAutoScroll(instance);
                instance.destroy();
            }
        }
        else {
            Angular2MaterializeV1Service_1.removeAutoScroll(instances);
            instances.destroy();
        }
    }
    dismissAllToasts() {
        if (isPlatformServer(this.platformId)) {
            return null;
        }
        return M.Toast.dismissAll();
    }
    initAutocomplete(elms, opts) {
        if (isPlatformServer(this.platformId)) {
            return null;
        }
        return M.Autocomplete.init(Angular2MaterializeV1Service_1.getElements(elms), opts);
    }
    initCarousel(elms, opts) {
        if (isPlatformServer(this.platformId)) {
            return null;
        }
        const instances = M.Carousel.init(Angular2MaterializeV1Service_1.getElements(elms), opts);
        if (Array.isArray(instances)) {
            for (const instance of instances) {
                this.addAutoScroll(instance);
            }
        }
        else {
            this.addAutoScroll(instances);
        }
        return instances;
    }
    initCharacterCount(elms) {
        if (isPlatformServer(this.platformId)) {
            return null;
        }
        return M.CharacterCounter.init(Angular2MaterializeV1Service_1.getElements(elms));
    }
    initCollapsible(elms, opts) {
        if (isPlatformServer(this.platformId)) {
            return null;
        }
        return M.Collapsible.init(Angular2MaterializeV1Service_1.getElements(elms), opts);
    }
    initDatePicker(elms, opts) {
        if (isPlatformServer(this.platformId)) {
            return null;
        }
        return M.Datepicker.init(Angular2MaterializeV1Service_1.getElements(elms), opts);
    }
    initDropdown(elms, opts) {
        if (isPlatformServer(this.platformId)) {
            return null;
        }
        return M.Dropdown.init(Angular2MaterializeV1Service_1.getElements(elms), opts);
    }
    initFloatingActionButton(elms, opts) {
        if (isPlatformServer(this.platformId)) {
            return null;
        }
        return M.FloatingActionButton.init(Angular2MaterializeV1Service_1.getElements(elms), opts);
    }
    initMaterialboxed(elms, opts) {
        if (isPlatformServer(this.platformId)) {
            return null;
        }
        return M.Materialbox.init(Angular2MaterializeV1Service_1.getElements(elms), opts);
    }
    initModal(elms, opts) {
        if (isPlatformServer(this.platformId)) {
            return null;
        }
        return M.Modal.init(Angular2MaterializeV1Service_1.getElements(elms), opts);
    }
    initParallax(elms, opts) {
        if (isPlatformServer(this.platformId)) {
            return null;
        }
        return M.Parallax.init(Angular2MaterializeV1Service_1.getElements(elms), opts);
    }
    initPushpin(elms, opts) {
        if (isPlatformServer(this.platformId)) {
            return null;
        }
        if (!opts) {
            opts = {};
        }
        const elements = Angular2MaterializeV1Service_1.getElements(elms);
        if (elements instanceof NodeList && !opts.offset) {
            const ret = [];
            // tslint:disable-next-line:prefer-for-of
            for (let i = 0; i < elements.length; ++i) {
                opts.offset = elements[i].offsetTop;
                ret.push(M.Pushpin.init(elements[i], opts));
            }
            return ret;
        }
        else if (elements instanceof HTMLElement && !opts.offset) {
            opts.offset = elements.offsetTop;
            return M.Pushpin.init(elements, opts);
        }
        else {
            return M.Pushpin.init(elements, opts);
        }
    }
    initScrollSpy(elms, opts) {
        if (isPlatformServer(this.platformId)) {
            return null;
        }
        return M.ScrollSpy.init(Angular2MaterializeV1Service_1.getElements(elms), opts);
    }
    initSelect(elms, opts) {
        if (isPlatformServer(this.platformId)) {
            return null;
        }
        return M.FormSelect.init(Angular2MaterializeV1Service_1.getElements(elms), opts);
    }
    initSidenav(elms, opts) {
        if (isPlatformServer(this.platformId)) {
            return null;
        }
        return M.Sidenav.init(Angular2MaterializeV1Service_1.getElements(elms), opts);
    }
    initSlider(elms, opts) {
        if (isPlatformServer(this.platformId)) {
            return null;
        }
        return M.Slider.init(Angular2MaterializeV1Service_1.getElements(elms), opts);
    }
    initTabs(elms, opts) {
        if (isPlatformServer(this.platformId)) {
            return null;
        }
        return M.Tabs.init(Angular2MaterializeV1Service_1.getElements(elms), opts);
    }
    initTapTarget(elms, opts) {
        if (isPlatformServer(this.platformId)) {
            return null;
        }
        return M.TapTarget.init(Angular2MaterializeV1Service_1.getElements(elms), opts);
    }
    initTooltip(elms, opts) {
        if (isPlatformServer(this.platformId)) {
            return null;
        }
        return M.Tooltip.init(Angular2MaterializeV1Service_1.getElements(elms), opts);
    }
    toast(opts) {
        if (isPlatformServer(this.platformId)) {
            return null;
        }
        return M.toast(opts);
    }
    updateTextFields() {
        if (isPlatformServer(this.platformId)) {
            return null;
        }
        return M.updateTextFields();
    }
};
Angular2MaterializeV1Service.ctorParameters = () => [
    { type: Object, decorators: [{ type: Inject, args: [PLATFORM_ID,] }] }
];
Angular2MaterializeV1Service.ɵprov = ɵɵdefineInjectable({ factory: function Angular2MaterializeV1Service_Factory() { return new Angular2MaterializeV1Service(ɵɵinject(PLATFORM_ID)); }, token: Angular2MaterializeV1Service, providedIn: "root" });
Angular2MaterializeV1Service = Angular2MaterializeV1Service_1 = __decorate([
    Injectable({
        providedIn: 'root'
    }),
    __param(0, Inject(PLATFORM_ID))
], Angular2MaterializeV1Service);

/*
 * Public API Surface of angular2-materialize-v1
 */

/**
 * Generated bundle index. Do not edit.
 */

export { Angular2MaterializeV1Service };
//# sourceMappingURL=angular2-materialize-v1.js.map
